-- 6/17 variant 2

-- Settings.TimeZoneOffset represents the number of hours to adjust local time to server time (either EST or EDT depending on DST)
-- so, in pacific time, Settings.TimeZoneOffset would be +3
-- in GMT, Settings.TimeZoneOffset would be -5
-- this allows the plugin to calculate 'day' based on servertime (minus 3 hours for the 3:00 AM reset time)
-- so at 2:59 AM on 6/5/2024, the day is 6/4/2024 (it hasn't switched to next day yet) but at 3:00 AM on 6/5/2024, the day is 6/5/2024

maliceWindow = Turbine.UI.Lotro.Window();
maliceWindow:SetZOrder(1)
maliceWindow.MoveX=-1;
maliceWindow.MoveY=-1;
maliceWindow:SetSize(initMaliceWidth,initMaliceHeight);
maliceWindow:SetPosition( initMaliceLeft, initMaliceTop );
maliceWindow:SetVisible(false);
maliceWindow:SetOpacity(Settings.Opacity);

maliceWindow:SetText(Resource[language][31]);

maliceWindow.MouseDown=function(sender,args)
	if maliceWindow.PopUp~=nil then
		maliceWindow.PopUpTop=mapWindow.PopUp:GetTop()
		maliceWindow.PopUpLeft=mapWindow.PopUp:GetLeft()
		maliceWindow.PopUp:SetVisible(false)
		maliceWindow.PopUp=nil -- dismiss the dialog
	end
	maliceWindow.Date.Calendar:SetVisible(false)
end

maliceWindow.MouseMove=function(sender,args)
end

maliceWindow.MouseUp=function(sender,args)
end

maliceWindow.MouseClick=function(sender,args)
	if args.Button==2 then
		-- user right clicked on malice window
	else
		-- user left clicked on malice window
	end
end

maliceWindow.SetTrimColor=function()
end
maliceWindow.SetBackColor=function()
end
maliceWindow.SetListTextColor=function()
end
maliceWindow.SetForeColor=function()
end
maliceWindow.SetHeadingsColor=function()
end
maliceWindow.SetLanguage=function()
	maliceWindow:SetText(Resource[language][2]);
end

maliceWindow:SetResizable(true)

maliceWindow.DateCaption=Turbine.UI.Label()
maliceWindow.DateCaption:SetParent(maliceWindow)
maliceWindow.DateCaption:SetPosition(10,45)
maliceWindow.DateCaption:SetSize(fontMetric:GetTextWidth(Resource[language][36]..":"),Turbine.UI.Lotro.FontInfo[Settings.Font].size)
maliceWindow.DateCaption:SetFont(Settings.Font)
maliceWindow.DateCaption:SetText(Resource[language][36]..":")
maliceWindow.DateCaption:SetMouseVisible(false)

maliceWindow.Date=DateBox()
maliceWindow.Date:SetParent(maliceWindow)
maliceWindow.Date:SetPosition(maliceWindow.DateCaption:GetLeft()+maliceWindow.DateCaption:GetWidth()+5,maliceWindow.DateCaption:GetTop())
--maliceWindow.Date:SetSize(fontMetric:GetTextWidth("88/88/8888x"),Turbine.UI.Lotro.FontInfo[Settings.Font].size)
maliceWindow.Date:SetFont(Settings.Font)
maliceWindow.Date.Calendar:SetLanguage(language)
--maliceWindow.Date:SetText(getCurrentDate(Settings.DateFormat))
do
	local date=Turbine.Engine:GetDate()
	maliceWindow.Month=date.Month
	maliceWindow.Day=date.Day
	maliceWindow.Year=date.Year
	maliceWindow.Date:SetDay(date.Day)
	maliceWindow.Date:SetMonth(date.Month)
	maliceWindow.Date:SetYear(date.Year)
end
maliceWindow.Date.DateChanged=function()
	local dateTime=Turbine.Engine.GetDate()
	dateTime.Month=maliceWindow.Date.Month
	dateTime.Day=maliceWindow.Date.Day
	dateTime.Year=maliceWindow.Date.Year
	displayVariant=getVariant(getEpochTime(dateTime))
	fillMaliceList(displayVariant)
	maliceWindow.SetFont()
	maliceWindow.Layout()	
end

maliceWindow.Time=Turbine.UI.Label()

maliceWindow.Time:SetParent(maliceWindow)
maliceWindow.Time:SetPosition(maliceWindow.Date:GetLeft()+maliceWindow.Date:GetWidth()+5,maliceWindow.Date:GetTop())
maliceWindow.Time:SetSize(fontMetric:GetTextWidth("88:88:88 "),Turbine.UI.Lotro.FontInfo[Settings.Font].size)
maliceWindow.Time:SetMultiline(false)
maliceWindow.Time:SetForeColor(Settings.ForeColor)
maliceWindow.Time:SetBackColor(Settings.BackColor)
maliceWindow.Time:SetFont(Settings.Font)

maliceWindow.VariantCaption=Turbine.UI.Label()
maliceWindow.VariantCaption:SetParent(maliceWindow)
maliceWindow.VariantCaption:SetTop(maliceWindow.DateCaption:GetTop())
maliceWindow.VariantCaption:SetText(Resource[language][22]..":")

maliceWindow.Variant=Turbine.UI.Label()
maliceWindow.Variant:SetParent(maliceWindow)
maliceWindow.Variant:SetTop(maliceWindow.VariantCaption:GetTop())
maliceWindow.Variant:SetText(displayVariant)
maliceWindow.Variant:SetMultiline(false)

--***
--maliceWindow.RefreshTodayVariant=Turbine.UI.Button()
--maliceWindow.RefreshTodayVariant:SetParent(maliceWindow)
--maliceWindow.RefreshTodayVariant:SetSize(16,16)
--maliceWindow.RefreshTodayVariant:SetBlendMode(Turbine.UI.BlendMode.Overlay)
--maliceWindow.RefreshTodayVariant:SetBackground(0x4111b60f)
--0x4111b60d - grey
--0x4111b60e - highlight
--0x4111b60f - normal
--maliceWindow.RefreshTodayVariant.Click=function()
--	_,todayVariant=math.modf(math.floor((Turbine.Engine:GetLocalTime()-baseMaliceDate)/86400)/6)
--	todayVariant=math.floor(todayVariant*6+.5)+1
--	maliceWindow.TodayVariant:SetText(todayVariant)
--	maliceWindow.RefreshTodayVariant:SetBackground(0x4111b60f) -- just in case
--end
--maliceWindow.RefreshTodayVariant.MouseDown=function()
--	maliceWindow.RefreshTodayVariant:SetBackground(0x4111b60e)
--end
--maliceWindow.RefreshTodayVariant.MouseLeave=function()
--	maliceWindow.RefreshTodayVariant:SetBackground(0x4111b60f)
--end
--maliceWindow.RefreshTodayVariant.MouseUp=function()
--	maliceWindow.RefreshTodayVariant:SetBackground(0x4111b60f)
--end

-- the main component, the "Malice List"
-- header row is Tier, Name, Description, Effect Name, Effect Description, Removal, Effect Duration
-- row height is determined by max of Description and Effect Description since they have a lot of text as well as multiple effects
maliceWindow.MaliceBack=Turbine.UI.Control()
maliceWindow.MaliceBack:SetParent(maliceWindow)
maliceWindow.MaliceBack:SetBackColor(Settings.TrimColor)
maliceWindow.MaliceBack:SetLeft(10)
maliceWindow.MaliceList=Turbine.UI.ListBox()
maliceWindow.MaliceList:SetParent(maliceWindow.MaliceBack)
maliceWindow.MaliceList:SetPosition(1,1)
maliceWindow.MaliceVScroll=Turbine.UI.Lotro.ScrollBar()
maliceWindow.MaliceVScroll:SetParent(maliceWindow)
maliceWindow.MaliceVScroll:SetWidth(10)
maliceWindow.MaliceVScroll:SetOrientation(Turbine.UI.Orientation.Vertical)
maliceWindow.MaliceList:SetVerticalScrollBar(maliceWindow.MaliceVScroll)

maliceHeading=Turbine.UI.Control()
maliceHeading:SetParent(maliceWindow.MaliceList)
maliceHeading.Tier=Turbine.UI.Label()
maliceHeading.Tier:SetParent(maliceHeading)
maliceHeading.Tier:SetText(Resource[language][24])
maliceHeading.Tier:SetBackColor(Settings.BackColor)

maliceHeading.Name=Turbine.UI.Label()
maliceHeading.Name:SetParent(maliceHeading)
maliceHeading.Name:SetText(Resource[language][25])
maliceHeading.Name:SetBackColor(Settings.BackColor)

maliceHeading.Description=Turbine.UI.Label()
maliceHeading.Description:SetParent(maliceHeading)
maliceHeading.Description:SetText(Resource[language][26])
maliceHeading.Description:SetBackColor(Settings.BackColor)

maliceHeading.Effect=Turbine.UI.Label()
maliceHeading.Effect:SetParent(maliceHeading)
maliceHeading.Effect:SetText(Resource[language][27])
maliceHeading.Effect:SetBackColor(Settings.BackColor)

maliceHeading.EffectDesc=Turbine.UI.Label()
maliceHeading.EffectDesc:SetParent(maliceHeading)
maliceHeading.EffectDesc:SetText(Resource[language][28])
maliceHeading.EffectDesc:SetBackColor(Settings.BackColor)
maliceHeading.EffectDesc.rgbText=Resource[language][28]

maliceHeading.Removal=Turbine.UI.Label()
maliceHeading.Removal:SetParent(maliceHeading)
maliceHeading.Removal:SetText(Resource[language][29])
maliceHeading.Removal:SetBackColor(Settings.BackColor)

maliceHeading.Duration=Turbine.UI.Label()
maliceHeading.Duration:SetParent(maliceHeading)
maliceHeading.Duration:SetText(Resource[language][30])
maliceHeading.Duration:SetBackColor(Settings.BackColor)

function fillMaliceList(variant)
	if variant==nil then variant=displayVariant end
	local currentDateTime=Turbine.Engine.GetDate()
--	if currentDateTime.Hour+Settings.TimeZoneOffset-3>24 then
--		maliceWindow.Time:SetForeColor(Turbine.UI.Color.Orange)
--	else
		maliceWindow.Time:SetForeColor(Settings.ForeColor)
--	end
	maliceWindow.Time:SetText(string.format("%02d:%02d:%02d",currentDateTime.Hour,currentDateTime.Minute,currentDateTime.Second))
	maliceWindow.Variant:SetText(variant)
	if maliceWindow.displayedVariant==nil or maliceWindow.displayedVariant~=variant then
		maliceWindow.displayedHour=Turbine.Engine:GetDate().Hour
		maliceWindow.displayedVariant=variant
--Turbine.Shell.WriteLine("variant:"..tostring(variant))
		maliceWindow.MaliceList:ClearItems()
		maliceWindow.MaliceList:AddItem(maliceHeading)
		for k=1,12 do
			local tmpRow=Turbine.UI.Control()
			tmpRow:SetParent(maliceWindow.MaliceList)
			tmpRow.Tier=Turbine.UI.Label()
			tmpRow.Tier:SetParent(tmpRow)
			tmpRow.Tier:SetFont(Settings.Font)
			tmpRow.Tier:SetText(k)
			tmpRow.Tier:SetBackColor(Settings.BackColor)

			tmpRow.Name=Turbine.UI.Label()
			tmpRow.Name:SetParent(tmpRow)
			tmpRow.Name:SetFont(Settings.Font)
			tmpRow.Name:SetText(EpicVariant[MaliceSchedule[variant][k]][1])
			tmpRow.Name:SetBackColor(Settings.BackColor)

			tmpRow.Description=Turbine.UI.Label()
			tmpRow.Description:SetParent(tmpRow)
			tmpRow.Description:SetFont(Settings.Font)
			tmpRow.Description:SetText(EpicVariant[MaliceSchedule[variant][k]][2])
			tmpRow.Description:SetBackColor(Settings.BackColor)

			tmpRow.Effect=Turbine.UI.Label()
			tmpRow.Effect:SetParent(tmpRow)
			tmpRow.Effect:SetFont(Settings.Font)
			local tmpEffect=EpicVariant[MaliceSchedule[variant][k]][3]
			if tmpEffect~=nil then
				if EpicEffect[tmpEffect]~=nil then
					tmpRow.Effect:SetText(EpicEffect[tmpEffect][1])
				else
					tmpRow.Effect:SetText("")
				end
			else
				tmpRow.Effect:SetText("")
			end
			tmpRow.Effect:SetBackColor(Settings.BackColor)

			tmpRow.EffectDesc=Turbine.UI.Label()
			tmpRow.EffectDesc:SetParent(tmpRow)
			tmpRow.EffectDesc:SetFont(Settings.Font)
			tmpRow.EffectDesc:SetMarkupEnabled(true)
			local tmpDesc=""
			if tmpEffect~=nil then
				if EpicEffect[tmpEffect]~=nil then
					if EpicEffect[tmpEffect][2]~=nil then
						tmpDesc=EpicEffect[tmpEffect][2]
					end
					if EpicEffect[tmpEffect][5]~=nil and type(EpicEffect[tmpEffect][5])=="table" then
						for k,v in ipairs(EpicEffect[tmpEffect][5]) do
							tmpDesc=tmpDesc..'\n<rgb=#c80000>'..tostring(v).."</rgb>"
						end
					end
				end
			end
			tmpRow.EffectDesc.rgbText=tmpDesc
			tmpRow.EffectDesc:SetText(tmpDesc)
			tmpRow.EffectDesc:SetBackColor(Settings.BackColor)

			tmpRow.Removal=Turbine.UI.Label()
			tmpRow.Removal:SetParent(tmpRow)
			tmpRow.Removal:SetFont(Settings.Font)
			if tmpEffect~=nil then
				if EpicEffect[tmpEffect]~=nil and EpicEffect[tmpEffect][3]~=nil then
					tmpRow.Removal:SetText(EpicEffect[tmpEffect][3])
				else
					tmpRow.Removal:SetText("")
				end
			else
				tmpRow.Removal:SetText("")
			end
			tmpRow.Removal:SetBackColor(Settings.BackColor)

			tmpRow.Duration=Turbine.UI.Label()
			tmpRow.Duration:SetParent(tmpRow)
			tmpRow.Duration:SetFont(Settings.Font)
			if tmpEffect~=nil then
				if EpicEffect[tmpEffect]~=nil and EpicEffect[tmpEffect][4]~=nil then
					tmpRow.Duration:SetText(EpicEffect[tmpEffect][4])
				else
					tmpRow.Duration:SetText("")
				end
			else
				tmpRow.Duration:SetText("")
			end
			tmpRow.Duration:SetBackColor(Settings.BackColor)

			maliceWindow.MaliceList:AddItem(tmpRow)
		end
	end
end
fillMaliceList(displayVariant)

--maliceWindow.FontSelect:SetBackColor(Turbine.UI.Color.Red)
maliceWindow.SetFont=function()
	-- use changed font
	local newFont=Settings.Font
	local fontHeight=Turbine.UI.Lotro.FontInfo[newFont].size
	fontMetric:SetFont(newFont)

	maliceWindow.DateCaption:SetSize(fontMetric:GetTextWidth(Resource[language][36]..":"),Turbine.UI.Lotro.FontInfo[Settings.Font].size)
	maliceWindow.DateCaption:SetFont(Settings.Font)
	maliceWindow.DateCaption:SetText(maliceWindow.DateCaption:GetText())
	maliceWindow.Date:SetSize(fontMetric:GetTextWidth("88/88/8888x"),Turbine.UI.Lotro.FontInfo[Settings.Font].size)
	maliceWindow.Date:SetFont(Settings.Font)

	maliceWindow.Time:SetFont(Settings.Font)
	maliceWindow.Time:SetSize(fontMetric:GetTextWidth("88:88:88 "),Turbine.UI.Lotro.FontInfo[Settings.Font].size)

	maliceWindow.VariantCaption:SetFont(newFont)
	maliceWindow.VariantCaption:SetWidth(fontMetric:GetTextWidth(maliceWindow.VariantCaption:GetText()))
	maliceWindow.VariantCaption:SetHeight(fontHeight)
	maliceWindow.VariantCaption:SetText(maliceWindow.VariantCaption:GetText())

	maliceWindow.Variant:SetFont(newFont)
	maliceWindow.Variant:SetWidth(fontMetric:GetTextWidth("8"))
	maliceWindow.Variant:SetHeight(fontHeight)
	maliceWindow.Variant:SetText(displayVariant)

-- handle table - FONT ISSUES ONLY - size/pos are handled in layout
	for k=1, maliceWindow.MaliceList:GetItemCount() do
		local tmpRow=maliceWindow.MaliceList:GetItem(k)
		tmpRow.Tier:SetFont(newFont)
		tmpRow.Tier:SetText(tmpRow.Tier:GetText())
		tmpRow.Name:SetFont(newFont)
		tmpRow.Name:SetText(tmpRow.Name:GetText())
		tmpRow.Description:SetFont(newFont)
		tmpRow.Description:SetText(tmpRow.Description:GetText())
		tmpRow.Effect:SetFont(newFont)
		tmpRow.Effect:SetText(tmpRow.Effect:GetText())
		tmpRow.EffectDesc:SetFont(newFont)
		tmpRow.EffectDesc:SetText(tmpRow.EffectDesc.rgbText)
		tmpRow.Removal:SetFont(newFont)
		tmpRow.Removal:SetText(tmpRow.Removal:GetText())
		tmpRow.Duration:SetFont(newFont)
		tmpRow.Duration:SetText(tmpRow.Duration:GetText())
	end

	--now call layout to reposition all these resized controls
	maliceWindow:Layout()
end
maliceWindow.Layout=function()
	-- layout controls
	maliceWindow.Date:SetLeft(maliceWindow.DateCaption:GetLeft()+maliceWindow.DateCaption:GetWidth()+5)
	maliceWindow.Time:SetLeft(maliceWindow.Date:GetLeft()+maliceWindow.Date:GetWidth()+5)
	maliceWindow.VariantCaption:SetLeft(maliceWindow.Time:GetLeft()+maliceWindow.Time:GetWidth()+10)
	maliceWindow.Variant:SetLeft(maliceWindow.VariantCaption:GetLeft()+maliceWindow.VariantCaption:GetWidth()+5)
--	maliceWindow.RefreshTodayVariant:SetLeft(maliceWindow.TodayVariant:GetLeft()+maliceWindow.TodayVariant:GetWidth()+15)
--	maliceWindow.RefreshTodayVariant:SetTop(maliceWindow.TodayVariant:GetTop()+maliceWindow.TodayVariant:GetHeight()/2-8) -- align middle of variant

	-- determine list layout (all remaining space)
	maliceWindow.MaliceBack:SetWidth(maliceWindow:GetWidth()-30)
	maliceWindow.MaliceBack:SetTop(maliceWindow.DateCaption:GetTop()+maliceWindow.DateCaption:GetHeight()+10)
	maliceWindow.MaliceBack:SetHeight(maliceWindow:GetHeight()-45-maliceWindow.MaliceBack:GetTop())
	local rowWidth=maliceWindow:GetWidth()-32
	maliceWindow.MaliceList:SetWidth(rowWidth)
	maliceWindow.MaliceList:SetHeight(maliceWindow.MaliceBack:GetHeight()-2)
	maliceWindow.MaliceVScroll:SetPosition(maliceWindow.MaliceBack:GetLeft()+maliceWindow.MaliceBack:GetWidth(),maliceWindow.MaliceBack:GetTop())
	maliceWindow.MaliceVScroll:SetHeight(maliceWindow.MaliceBack:GetHeight())
	-- handle table layout
	local headerRow=maliceWindow.MaliceList:GetItem(1)
	local tierWidth=fontMetric:GetTextWidth(headerRow.Tier:GetText()..".")
	local nameWidth=fontMetric:GetTextWidth(headerRow.Name:GetText()..".")
	local effectWidth=fontMetric:GetTextWidth(headerRow.Effect:GetText()..".")
	local removalWidth=fontMetric:GetTextWidth(headerRow.Removal:GetText()..".")
	local durationWidth=fontMetric:GetTextWidth(headerRow.Duration:GetText()..".")
	for k=2,maliceWindow.MaliceList:GetItemCount() do
		-- need to adjust nameWidth, effectWidth and removalWidth based on width of actual text as Text may be wider than Caption
		local tmpRow=maliceWindow.MaliceList:GetItem(k)
		local tmpWidth=fontMetric:GetTextWidth(tmpRow.Name:GetText())
		if tmpWidth>nameWidth then nameWidth=tmpWidth end
		tmpWidth=fontMetric:GetTextWidth(tmpRow.Effect:GetText())
		if tmpWidth>effectWidth then effectWidth=tmpWidth end
		tmpWidth=fontMetric:GetTextWidth(tmpRow.Removal:GetText())
		if tmpWidth>removalWidth then removalWidth=tmpWidth end
	end
	-- split remainder between descriptions
	local descriptionWidth=(rowWidth-tierWidth-nameWidth-effectWidth-removalWidth-durationWidth-6)/2
	local effectDescWidth=descriptionWidth

	local even=true
	local bgColor
	for k=1,maliceWindow.MaliceList:GetItemCount() do
		local tmpRow=maliceWindow.MaliceList:GetItem(k)
		bgColor=Turbine.UI.Color(.1,.1,.2)
		if k>1 then
			if even then
				bgColor=Turbine.UI.Color(.1,.1,.1)
			else
				bgColor=Turbine.UI.Color(.05,.05,.1)
			end
		end
		tmpRow:SetWidth(rowWidth)
		tmpRow.Tier:SetWidth(tierWidth)
		tmpRow.Tier:SetBackColor(bgColor)
		tmpRow.Name:SetLeft(tierWidth+1)
		tmpRow.Name:SetWidth(nameWidth)
		tmpRow.Name:SetBackColor(bgColor)
		tmpRow.Description:SetLeft(tmpRow.Name:GetLeft()+nameWidth+1)
		tmpRow.Description:SetWidth(descriptionWidth)
		tmpRow.Description:SetBackColor(bgColor)
		tmpRow.Effect:SetWidth(effectWidth)
		tmpRow.Effect:SetLeft(tmpRow.Description:GetLeft()+descriptionWidth+1)
		tmpRow.Effect:SetBackColor(bgColor)
		tmpRow.EffectDesc:SetWidth(effectDescWidth)
		tmpRow.EffectDesc:SetLeft(tmpRow.Effect:GetLeft()+effectWidth+1)
		tmpRow.EffectDesc:SetBackColor(bgColor)
		tmpRow.Removal:SetWidth(removalWidth)
		tmpRow.Removal:SetLeft(tmpRow.EffectDesc:GetLeft()+effectDescWidth+1)
		tmpRow.Removal:SetBackColor(bgColor)
		tmpRow.Duration:SetWidth(durationWidth)
		tmpRow.Duration:SetLeft(tmpRow.Removal:GetLeft()+removalWidth+1)
		tmpRow.Duration:SetBackColor(bgColor)
		-- determine height from max(description, effectDesc) height
		local rowHeight=fontMetric:GetTextHeight(tmpRow.Description:GetText(),descriptionWidth)
		local effectDescHeight=fontMetric:GetTextHeight(tmpRow.EffectDesc:GetText(),effectDescWidth)
		if effectDescHeight>rowHeight then rowHeight=effectDescHeight end
		tmpRow:SetHeight(rowHeight+1)
		tmpRow.Tier:SetHeight(rowHeight)
		tmpRow.Name:SetHeight(rowHeight)
		tmpRow.Description:SetHeight(rowHeight)
		tmpRow.Effect:SetHeight(rowHeight)
		tmpRow.EffectDesc:SetHeight(rowHeight)
		tmpRow.Removal:SetHeight(rowHeight)
		tmpRow.Duration:SetHeight(rowHeight)
		even=not even
	end
end
maliceWindow.SizeChanged=function()
	local width,height=maliceWindow:GetSize()
	if width<100 then
		width=MinWidth
		maliceWindow:SetWidth(width)
	end
	if height<30 then
		height=MinHeight
		maliceWindow:SetHeight(height)
	end
	maliceWindow:Layout()
end
maliceWindow.Closing=function()
	maliceWindow.Date.Calendar:SetVisible(false)
end
maliceWindow.Update=function(sender,args)
	if maliceWindow.updateTime==nil or Turbine.Engine:GetGameTime()>maliceWindow.updateTime then
		if maliceWindow.displayedHour==nil or maliceWindow.displayedHour~=Turbine.Engine:GetDate().Hour then
			maliceWindow.displayedHour=Turbine.Engine:GetDate().Hour
			local dateTime=Turbine.Engine.GetDate()
			dateTime.Month=maliceWindow.Date.Month
			dateTime.Day=maliceWindow.Date.Day
			dateTime.Year=maliceWindow.Date.Year
			fillMaliceList(getVariant(getEpochTime(dateTime)))
		else
			fillMaliceList(maliceWindow.displayedVariant)
		end
		maliceWindow.Layout()
		maliceWindow.updateTime=Turbine.Engine:GetGameTime()+1
	end
end

maliceWindow.VisibleChanged=function()
	maliceWindow:SetWantsUpdates(maliceWindow:IsVisible())
end

maliceWindow.SetFont() -- assign the current font and call layout
-- main window should show the current malice Variant by default with Variant being in a dropdown so that other Variants can be shown , epic malice version across top
-- tiers 1-12 should be down the side with malice name / description / effect shown

initMaliceLeft=nil
initMaliceTop=nil
initMaliceWidth=nil
initMaliceHeight=nil
